os_loadbalancer – Add/Delete load balancer from OpenStack Cloud — Ansible Documentation

- AnsibleFest
- Products
- Community
- Webinars & Training
- Blog

Documentation

# os_loadbalancer – Add/Delete load balancer from OpenStack Cloud

New in version 2.7.

- Synopsis
- Requirements
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- Add or Remove load balancer from the OpenStack load-balancer service(Octavia). Load balancer update is not supported for now.

## Requirements

The below requirements are needed on the host that executes this module.

- openstacksdk
- openstacksdk >= 0.12.0
- python >= 2.7

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
api_timeout integer |  | How long should the socket layer wait before timing out for API calls. If this is omitted, nothing will be passed to the requests library.
auth dictionary |  | Dictionary containing auth information as needed by the cloud's auth plugin strategy. For the default password plugin, this would contain auth_url, username, password, project_name and any information about domains (for example, os_user_domain_name or os_project_domain_name) if the cloud supports them. For other plugins, this param will need to contain whatever parameters that auth plugin requires. This parameter is not needed if a named cloud is provided or OpenStack OS_* environment variables are present.
auth_type string |  | Name of the auth plugin to use. If the cloud uses something other than password authentication, the name of the plugin should be indicated here and the contents of the auth parameter should be updated accordingly.
auto_public_ip boolean | Choices: no ← yes | Allocate a public IP address and associate with the VIP automatically.
availability_zone - |  | Ignored. Present for backwards compatibility
ca_cert string |  | A path to a CA Cert bundle that can be used as part of verifying SSL API requests. aliases: cacert
client_cert string |  | A path to a client certificate to use as part of the SSL transaction. aliases: cert
client_key string |  | A path to a client key to use as part of the SSL transaction. aliases: key
cloud raw |  | Named cloud or cloud config to operate against. If cloud is a string, it references a named cloud config as defined in an OpenStack clouds.yaml file. Provides default values for auth and auth_type. This parameter is not needed if auth is provided or if OpenStack OS_* environment variables are present. If cloud is a dict, it contains a complete cloud configuration like would be in a section of clouds.yaml.
delete_public_ip boolean | Choices: no ← yes | When `state=absent` and this option is true, any public IP address associated with the VIP will be deleted along with the load balancer.
interface string | Choices: admin internal public ← | Endpoint URL type to fetch from the service catalog. aliases: endpoint_type
listeners - |  | A list of listeners that attached to the load balancer.
| name - |  | The listener name or ID.
| pool - |  | The pool attached to the listener.
|  | lb_algorithm - | Default: "ROUND_ROBIN" | The load balancing algorithm for the pool.
|  | members - |  | A list of members that added to the pool.
|  |  | address - |  | The IP address of the member.
|  |  | name - |  | The member name or ID.
|  |  | protocol_port - | Default: 80 | The protocol port number for the member.
|  |  | subnet - |  | The name or ID of the subnet the member service is accessible from.
|  | name - |  | The pool name or ID.
|  | protocol - | Default: "HTTP" | The protocol for the pool.
| protocol - | Default: "HTTP" | The protocol for the listener.
| protocol_port - | Default: 80 | The protocol port number for the listener.
name - / required |  | Name that has to be given to the load balancer
public_ip_address - |  | Public IP address associated with the VIP.
public_network - |  | The name or ID of a Neutron external network.
region_name string |  | Name of the region.
state - | Choices: present ← absent | Should the resource be present or absent.
timeout integer | Default: 180 | The amount of time the module should wait.
validate_certs boolean | Choices: no ← yes | Whether or not SSL API requests should be verified. Before Ansible 2.3 this defaulted to `yes`. aliases: verify
vip_address - |  | IP address of the load balancer virtual IP.
vip_network - |  | The name or id of the network for the virtual IP of the load balancer. One of vip_network, vip_subnet, or vip_port must be specified for creation.
vip_port - |  | The name or id of the load balancer virtual IP port. One of vip_network, vip_subnet, or vip_port must be specified for creation.
vip_subnet - |  | The name or id of the subnet for the virtual IP of the load balancer. One of vip_network, vip_subnet, or vip_port must be specified for creation.
wait boolean | Choices: no yes ← | If the module should wait for the load balancer to be created or deleted.

## Notes

Note

- The standard OpenStack environment variables, such as `OS_USERNAME` may be used instead of providing explicit values.
- Auth information is driven by openstacksdk, which means that values can come from a yaml config file in /etc/ansible/openstack.yaml, /etc/openstack/clouds.yaml or ~/.config/openstack/clouds.yaml, then from standard environment variables, then finally by explicit parameters in plays. More information can be found at https://docs.openstack.org/openstacksdk/

## Examples

    # Create a load balancer by specifying the VIP subnet.
    - os_loadbalancer:
        auth:
          auth_url: https://identity.example.com
          username: admin
          password: passme
          project_name: admin
        state: present
        name: my_lb
        vip_subnet: my_subnet
        timeout: 150

    # Create a load balancer by specifying the VIP network and the IP address.
    - os_loadbalancer:
        auth:
          auth_url: https://identity.example.com
          username: admin
          password: passme
          project_name: admin
        state: present
        name: my_lb
        vip_network: my_network
        vip_address: 192.168.0.11

    # Create a load balancer together with its sub-resources in the 'all in one'
    # way. A public IP address is also allocated to the load balancer VIP.
    - os_loadbalancer:
        auth:
          auth_url: https://identity.example.com
          username: admin
          password: passme
          project_name: admin
        name: lingxian_test
        state: present
        vip_subnet: kong_subnet
        auto_public_ip: yes
        public_network: public
        listeners:
          - name: lingxian_80
            protocol: TCP
            protocol_port: 80
            pool:
              name: lingxian_80_pool
              protocol: TCP
              members:
                - name: mywebserver1
                  address: 192.168.2.81
                  protocol_port: 80
                  subnet: webserver_subnet
          - name: lingxian_8080
            protocol: TCP
            protocol_port: 8080
            pool:
              name: lingxian_8080-pool
              protocol: TCP
              members:
                - name: mywebserver2
                  address: 192.168.2.82
                  protocol_port: 8080
        wait: yes
        timeout: 600

    # Delete a load balancer(and all its related resources)
    - os_loadbalancer:
        auth:
          auth_url: https://identity.example.com
          username: admin
          password: passme
          project_name: admin
        state: absent
        name: my_lb

    # Delete a load balancer(and all its related resources) together with the
    # public IP address(if any) attached to it.
    - os_loadbalancer:
        auth:
          auth_url: https://identity.example.com
          username: admin
          password: passme
          project_name: admin
        state: absent
        name: my_lb
        delete_public_ip: yes

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
id string | On success when `state=present` | The load balancer UUID. Sample: 39007a7e-ee4f-4d13-8283-b4da2e037c69
loadbalancer complex | On success when `state=present` | Dictionary describing the load balancer.
| id string |  | Unique UUID. Sample: 39007a7e-ee4f-4d13-8283-b4da2e037c69
| is_admin_state_up boolean |  | The administrative state of the load balancer. Sample: True
| listeners list |  | The associated listener IDs, if any. Sample: [{'id': '7aa1b380-beec-459c-a8a7-3a4fb6d30645'}, {'id': '692d06b8-c4f8-4bdb-b2a3-5a263cc23ba6'}]
| name string |  | Name given to the load balancer. Sample: lingxian_test
| operating_status string |  | The operating status of the load balancer. Sample: ONLINE
| pools list |  | The associated pool IDs, if any. Sample: [{'id': '27b78d92-cee1-4646-b831-e3b90a7fa714'}, {'id': 'befc1fb5-1992-4697-bdb9-eee330989344'}]
| provisioning_status string |  | The provisioning status of the load balancer. Sample: ACTIVE
| public_vip_address string |  | The load balancer public VIP address. Sample: 10.17.8.254
| vip_address string |  | The load balancer virtual IP address. Sample: 192.168.2.88
| vip_network_id string |  | Network ID the load balancer virtual IP port belongs in. Sample: f171db43-56fd-41cf-82d7-4e91d741762e
| vip_port_id string |  | The load balancer virtual IP port ID. Sample: 2061395c-1c01-47ab-b925-c91b93df9c1d
| vip_subnet_id string |  | Subnet ID the load balancer virtual IP port belongs in. Sample: c53e3c70-9d62-409a-9f71-db148e7aa853

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- Lingxian Kong (@lingxiankong)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.